#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Pack.H>

// Test new Fl_Pack features for right-to-left and bottom-to-top

#define DEBUG

void MakePack(int type, int doresize, int &Y) {
  Fl_Pack *pack;
  {
      int h = type & Fl_Pack::HORIZONTAL ? 25 : 100;
      pack = new Fl_Pack(10,Y,620-20,h); Y+=pack->h()+10;
      pack->type(type);
      pack->spacing(5);
#ifdef DEBUG
      pack->box(FL_BORDER_FRAME); pack->color(FL_GREEN);
#endif
      pack->begin();
      {
	Fl_Button *but;
	but = new Fl_Button(0,10,100,25,"Aaa");
	if ( doresize==1 ) {
	  but->label("Resizable");
	  pack->resizable(but);
        }
	but = new Fl_Button(0,10,100,25,"Bbb");
	but = new Fl_Button(0,10,100,25,"Ccc");
	if ( doresize==2 ) {
	  but->label("Resizable");
	  pack->resizable(but);
        }
      }
      pack->end();
  }
}
int main() {
  Fl_Window *win = new Fl_Window(620,620,"Test Fl_Pack");
  win->box(FL_BORDER_BOX);
  int Y = 10;

  MakePack(Fl_Pack::HORIZONTAL|Fl_Pack::LEFT,  1, Y); // Horiz Left Justified Resizable
  MakePack(Fl_Pack::HORIZONTAL|Fl_Pack::RIGHT, 2, Y); // Horiz Right Justified Resizable
  MakePack(Fl_Pack::HORIZONTAL|Fl_Pack::LEFT,  0, Y); // Horiz Left Justified No Resizable
  MakePack(Fl_Pack::HORIZONTAL|Fl_Pack::RIGHT, 0, Y); // Horiz Right Justified No Resizable

  MakePack(Fl_Pack::VERTICAL|Fl_Pack::TOP,    1, Y); // Vert Top Justified Resizable
  MakePack(Fl_Pack::VERTICAL|Fl_Pack::BOTTOM, 2, Y); // Vert Bottom Justified Resizable
  MakePack(Fl_Pack::VERTICAL|Fl_Pack::TOP,    0, Y); // Vert Top Justified No Resizable
  MakePack(Fl_Pack::VERTICAL|Fl_Pack::BOTTOM, 0, Y); // Vert Bottom Justified No Resizable

  win->resizable(win);
  win->show();
  return(Fl::run());
}
